"""
ChannelTag automatically generated by SDKgen please do not edit this file manually
https://sdkgen.app
"""

import requests
import sdkgen
from requests import RequestException
from typing import List

from .channel import Channel
from .channel_message_tag import ChannelMessageTag
from .channel_reaction_tag import ChannelReactionTag
from .error_exception import ErrorException
from .message import Message

class ChannelTag(sdkgen.TagAbstract):
    def __init__(self, http_client: requests.Session, parser: sdkgen.Parser):
        super().__init__(http_client, parser)

    def message(self) -> ChannelMessageTag:
        return ChannelMessageTag(
            self.http_client,
            self.parser
        )

    def reaction(self) -> ChannelReactionTag:
        return ChannelReactionTag(
            self.http_client,
            self.parser
        )


    def get(self, channel_id: str) -> Channel:
        """
        Get a channel by ID. Returns a channel object.
        """
        try:
            path_params = {}
            path_params["channel_id"] = channel_id

            query_params = {}

            query_struct_names = []

            url = self.parser.url("/channels/:channel_id", path_params)

            headers = {}

            response = self.http_client.get(url, headers=headers, params=self.parser.query(query_params, query_struct_names))

            if response.status_code >= 200 and response.status_code < 300:
                return Channel.model_validate_json(json_data=response.content)

            if response.status_code == 400:
                raise ErrorException(response.content)
            if response.status_code == 404:
                raise ErrorException(response.content)
            if response.status_code == 500:
                raise ErrorException(response.content)

            raise sdkgen.UnknownStatusCodeException("The server returned an unknown status code")
        except RequestException as e:
            raise sdkgen.ClientException("An unknown error occurred: " + str(e))

    def get_pins(self, channel_id: str) -> List[Message]:
        """
        Returns all pinned messages in the channel as an array of message objects.
        """
        try:
            path_params = {}
            path_params["channel_id"] = channel_id

            query_params = {}

            query_struct_names = []

            url = self.parser.url("/channels/:channel_id/pins", path_params)

            headers = {}

            response = self.http_client.get(url, headers=headers, params=self.parser.query(query_params, query_struct_names))

            if response.status_code >= 200 and response.status_code < 300:
                return List[Message].model_validate_json(json_data=response.content)

            if response.status_code == 400:
                raise ErrorException(response.content)
            if response.status_code == 404:
                raise ErrorException(response.content)
            if response.status_code == 500:
                raise ErrorException(response.content)

            raise sdkgen.UnknownStatusCodeException("The server returned an unknown status code")
        except RequestException as e:
            raise sdkgen.ClientException("An unknown error occurred: " + str(e))


